import { useCallback, useRef, useState } from "react";

export default function useCountDown() {

  const [val, setVal] = useState()
  const numRef = useRef()

  const countDown = useCallback(() => {
    if (numRef.current <= 0) {
      return
    }
    numRef.current -= 1
    setVal(numRef.current)
  }, [])

  const start = useCallback((startNum) => {
    numRef.current = startNum
    setVal(startNum)
  }, [])

  return [val, countDown, start]
}
