
import { useEffect, useMemo, useRef, useState } from 'react';
import { useThrottle, useThrottleFn } from 'ahooks';
import Taro from '@tarojs/taro';
import { View } from '@tarojs/components'
import Counter from '@/components/Counter'
import { Button } from '@antmjs/vantui';
import useInterval from '@/hooks/useInterval';
import wexMP3 from '@/components/voice/wexMP3.mp3'

import { score } from '../../services/user';

import TopBar from './components/TopBar'
import useCountDown from './hooks/useCountDown';
import useShake from './hooks/useShake';
import { useModel } from '../../store'

import './index.less'

const IndexPage = (props) => {
  const modRef = useRef('ready')

  const [num, setNum] = useState(0)
  const [btnDisable, setBtnDisable] = useState(false)
  const { getAvatar, sessionKey, person, tologin } = useModel('useFoo')
  const [buttonTitle, setbuttonTitle] = useState(true)

  // 定时器
  const [add2TickerList] = useInterval(1400)

  // 倒计时
  const [count, countFn, startCount] = useCountDown();
  useMemo(() => add2TickerList(countFn), [])


  const [state, setstate] = useState(true)
  const { run } = useThrottleFn(
    () => {
      setTimeout(() => {
        state ? Taro.vibrateLong() : ''

      }, 30000);
    },
    { wait: 30000 },
  );



  // 摇一摇
  const [times, startShake, onShakeEnd] = useShake()

  console.log("🚀 ~ file: index.jsx ~ line 49 ~ IndexPage ~ times", times)
  useEffect(() => {



    if (times >= 2) {
      setTimeout(() => {

        run()

        //添加音效
        const innerAudioContext = Taro.createInnerAudioContext()
        innerAudioContext.autoplay = true// 是否自动开始播放，默认为 false
        innerAudioContext.loop = false  // 是否循环播放，默认为 false
        Taro.setInnerAudioOption({ // ios在静音状态下能够正常播放音效
          obeyMuteSwitch: false,   // 即使用户打开了静音开关，也能继续发出声音。
          success: function (e) {
            console.log(e)
            console.log('play success')
          },
          fail: function (e) {
            console.log(e)
            console.log('play fail')
          }
        })
        innerAudioContext.src = wexMP3
        innerAudioContext.onPlay(() => {
          console.log('开始播放')
        })
        innerAudioContext.onError((res) => {
          console.log(res.errMsg)
          console.log(res.errCode)
        })
        setTimeout(() => {
          //定时清理destroy这个context。不然这个context就算stop了，内存还是被占用。
          innerAudioContext.stop();

          innerAudioContext.destroy();

          innerAudioContext = null;

        }, 10000);


      }, 2000)


    }

  }, [state, times])

  onShakeEnd(() => {
    // 摇一摇结束

    Taro.showToast({
      title: '游戏结束',
      icon: 'none',
      duration: 5000


    }).then(e => {
      score({ personId: person?.personId, createDate: person?.createDate, score: times }).then(e => {
        modRef.current = 'ready'
        setBtnDisable(false)
        console.log(" 摇一摇结束")
        setbuttonTitle(false)
        setstate(false)


      })

    })

    // do something
  })



  const handleStart = () => {
    if (tologin == false) {
      Taro.showToast({
        title: '未登陆',
        icon: 'none',
        duration: 2000,
      })
    } else {
      if (!person?.avatar) {
        Taro.getUserProfile({
          lang: 'zh_CN',
          desc: "获取你的昵称、头像、地区及性别",
          success: (res) => {
            const data = {
              encryptedData: res.encryptedData,
              iv: res.iv,
              rawData: res.rawData,
              sessionKey: sessionKey,
              signature: res.signature
            }
            getAvatar(data)
            Taro.showToast({
              title: '授权头像成功',
              icon: 'success',
              duration: 2000
            })


          },
          fail: () => {
            //拒绝授权
            console.error("拒绝了请求");
            return;
          }
        })
      } else {

        modRef.current = 'countdown'
        startCount(3)
        setBtnDisable(true)

        // startShake(() => {
        //   console.log('kaissssssssssssssssss',);
        // })

      }
    }









  }

  useEffect(() => {
    if (modRef.current === 'countdown') {
      setNum(count)
    } else {
      setNum(times)
    }
  }, [count, times])

  useEffect(() => {
    if (modRef.current === 'countdown') {
      if (count === 0) {
        modRef.current = 'shake'
        startShake()
        setNum('Go!')

      }
    }
  }, [count])


  return (
    <View className='page-wrapper page-index'>
      <Counter className='shake-bg' value={num} />
      <TopBar />
      <View style={{ width: '80vw', position: 'fixed', bottom: '2em', left: '10vw' }} >
        <Button
          block
          round
          color='linear-gradient(to right, rgb(255, 96, 52), rgb(238, 10, 36))'
          onClick={handleStart}
          disabled={btnDisable}
        >{buttonTitle ? '开始游戏' : '继续游戏'}</Button>
      </View>
    </View>
  )
}

export default IndexPage;
