import { useState } from "react"
import Taro, { stopDeviceMotionListening } from '@tarojs/taro'
import { userLogin, authAvatar } from '../../services/user'




export default function useUser() {
  const [user, setUser] = useState({})
  const [person, setPerson] = useState()
  const [sessionKey, setSessionKey] = useState()

  // 是否登陆
  const [tologin, setTologin] = useState(false)



  const signIn = (params) => {
    userLogin(params.code).then((res) => {
      const { person: taPerson, skey, token } = res;
      setPerson(taPerson);
      setSessionKey(skey);
      Taro.setStorage({ key: 'token', data: token })
      setTologin(true)
    }).catch(e => {
      setTologin(false)

      if (tologin === false) {
        Taro.showModal({
          title: '提示',
          content: `系统错误，请退出后重试`,
          success: function (res) {
            setTologin(false)

            if (res.confirm) {
              Taro.navigateBack({
                delta: 0
              })
            } else if (res.cancel) {
              Taro.navigateBack({
                delta: 0
              })
            }
          }
        })
      }



    })
  }

  const signOut = () => {
    // xxx
  }

  const getAvatar = (data) => {
    return authAvatar(data).then((res) => {
      setPerson(res);
    })
  }

  return {
    user,
    person,
    sessionKey,
    tologin,

    signIn,
    signOut,
    getAvatar,

  }
}
